/* Testarea gestionarului de pozitionare FlowLayout.

   In fereastra aplicatiei apar mai multe butoane din clasa
   ButonContor si un buton de anulare, a carui apasare anulaza
   toate contoarele.

   La lansarea in executie se da ca parametru in linia de comanda
   numarul de butoane de contorizare
*/

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class ButoaneF { 
 static AF af=new AF(); // ascultatorul de fereastra
 static Anulare anulare=new Anulare(); // ascultatorul
                                       // butonului de anulare
 static IUG iug;  // fereastra aplicatiei
 static int numarButoane;

 static class IUG extends JFrame {
  JLabel lab=new JLabel("Actionati butoanele");
  ButonContor bc[];
  JButton br=new JButton("Reset"); 

  IUG(String titlu) { // constructorul ferestrei aplicatiei
   super(titlu);
   Container cp=getContentPane();
   setSize(300,150);
   setLocation(200,150);
   addWindowListener(af);
   cp.setLayout(new FlowLayout()); // setarea gestionarului
                                   // de pozitionare
   bc=new ButonContor[numarButoane];
   for(int i=0; i<numarButoane; i++) { 
    bc[i]=new ButonContor("B"+(i+1)); // crearea butoanelor
    cp.add(bc[i]); // adaugarea butoanelor la contentPane
   }
   cp.add(br); // adaugarea butonului de anulare
   br.addActionListener(anulare); // adaugarea ascultatorului
   setVisible(true);
  }
 }

 static class AF extends WindowAdapter { 
  public void windowClosing(WindowEvent e) {
   System.exit(0);
  }
 }

 static class Anulare implements ActionListener {
  public void actionPerformed(ActionEvent e) {
    for(int i=0; i<numarButoane; i++) iug.bc[i].reset();
  }
 }

 public static void main(String args[]) throws Exception {
  if(args.length!=1) {
    System.out.println("Utilizare: java ButoaneF <numarButoane>");
    System.exit(1);
  }
  numarButoane=Integer.parseInt(args[0]); // crearea tabloului de 
                                          // butoane
  iug=new IUG("FlowLayout cu "+numarButoane+
   " butoane de contorizare"); // crearea ferestrei aplicatiei
 }
}
  